<template>
	<view class="content">
		<view class="headbgbox flex2">

			<view class="searchbox">
				<u-icon name="search" bold="true" size="25" color="rgb(246,185,78)"></u-icon>
				<input type="text" v-model="keywords" placeholder="合同名称/编号、承兑人名称或出票人名称"
					placeholder-style="color:#BBBCBE" @blur="changeSeach"/>
			</view>
			<view class="screen" @click="show = true">
				<text>筛选</text>
				<view style="padding-left: 10rpx;">
					<u-icon name="arrow-down" color="#1F242A" size="14" bold="true"></u-icon>
				</view>
			</view>
		</view>
		<view class="cardlist">
			<view>
				<view class="lable " v-for="(item,index) in listall" :key="index">
					<view class="radiobox" v-if="editall">
						<radio :value="index" :checked="item.checked" color="#D8AB5A" @click="checkBox(item.id)" />
					</view>

					<view class="card" @click.stop="moveDetail(item.id)">
						<view class="passreview" v-if="item.statusText=='成功'">
							<image src="../../static/img/resuccess.png" mode="aspectFill"></image>
						</view>
						<view class="passreview" v-if="item.statusText=='待审核'">
							<image src="../../static/img/toreviewe.png" mode="aspectFill"></image>
						</view>
						<view class="passreview" v-if="item.statusText=='失败'">
							<image src="../../static/img/falis.png" mode="aspectFill"></image>
						</view>
						<view class="passreview" v-if="item.statusText=='已删除'">
							<image src="../../static/img/redel.png" mode="aspectFill"></image>
						</view>
						<view class="timebox" v-if="item.statusText=='成功'"><text>{{item.createdAt}}</text></view>
						<view class="timebox" v-if="item.statusText=='待审核'" :style="{'background-color':'#FFEBE5'}">
							<text>{{item.createdAt}}</text>
						</view>
						<view class="timebox" v-if="item.statusText=='失败'" :style="{'background-color':'#E7E7E7'}">
							<text>{{item.createdAt}}</text>
						</view>
						<view class="timebox" v-if="item.statusText=='已删除'" :style="{'background-color':'#F6F6F6'}">
							<text>{{item.createdAt}}</text>
						</view>
						<view class="innerbox">
							<view class="listicon">
								<image src="/static/img/listticon.png" mode="aspectFill"></image>
							</view>
							<text class="cardtitle hideone">{{item.name}}</text>
						</view>
						<view class="contractmsg flex5">
							<text>合同编号：{{item.contractNo}}</text>
							<text style="padding-top: 10rpx;">承兑人：{{item.acceptorName}}</text>
							<text style="padding-top: 10rpx;" v-if="state==0">供应商：{{item.supplierName}}</text>
						</view>
						<view class="flex6 contadra">
							<text>出票人：{{item.drawersName}}</text>
							<text>汇票状态：{{item.contractStatusText}}</text>
						</view>
					</view>
				</view>

			</view>

		</view>
		<view class="nomore" v-if="listall.length==0">
			<text>暂无数据</text>
		</view>
		<view class="totalmanage " v-if="listall.length>0">
			<text style="color:#68625B;font-size: 28rpx;">合计：{{total}}份</text>
			<view class=" maboxtitls" @click="editall=true">
				<view class="managebox">
					<image src="/static/img/manage.png" mode="aspectFit"></image>
				</view>
				<text style="padding-left: 15rpx;">管理</text>
			</view>
		</view>
		<view class="safebt"></view>
		<!-- <view class="plusicon" @click="addContract" v-if="state==1"></view> -->
		<u-popup :show="show" @close="close" @open="open">
			<view class="popscreen">
				<view class="checklist" v-for="(item,index) in ctrstatus" :key="index">
					<view class="alllistbtn">
						<text class="btntitle" style="">{{item.title}}</text>
						<view class="yunbtn">
							<view class="btnchoose" v-for="(i,k) in item.list" :key="k" @click="choose(item.title,k)"
								:class="[contract_status == k?'active':'btnchoose']">
								<text>{{i.name}}</text>
							</view>
						</view>
					</view>
				</view>
				<view class="checklist" v-for="(item,index) in billstatus" :key="index">
					<view class="alllistbtn">
						<text class="btntitle" style="">{{item.title}}</text>
						<view class="yunbtn">
							<view class="btnchoose" v-for="(i,k) in item.list" :key="k" @click="choose(item.title,k)"
								:class="[draft_status == k?'active':'btnchoose']">
								<text>{{i.name}}</text>
							</view>
						</view>
					</view>
				</view>
				<view class="checklist" v-for="(item,index) in upstauts" :key="index">
					<view class="alllistbtn">
						<text class="btntitle" style="">{{item.title}}</text>
						<view class="yunbtn">
							<view class="btnchoose" v-for="(i,k) in item.list" :key="k" @click="choose(item.title,k)"
								:class="[time_status == k?'active':'btnchoose']">
								<text>{{i.name}}</text>
							</view>
						</view>
					</view>
				</view>
				<view class="flex4 custom" v-if="time_status==3">
					<text style="font-size: 26rpx;font-weight: 600;">自定义</text>
					<view class="custombox flex3">
						<view class="creatdata flex6">
							<text>开始日期</text>
							<view class="flex4 chodatain" @click="openDatePicker(1)">
								<text>{{creatTime}}</text>
								<u-icon name="arrow-right" color="#BEBDBB" bold="true" size="12"></u-icon>
							</view>
						</view>
						<view class="creatdata flex6">
							<text>结束日期</text>
							<view class="flex4 chodatain" @click="openDatePicker(2)">
								<text>{{endTime}}</text>
								<u-icon name="arrow-right" color="#BEBDBB" bold="true" size="12"></u-icon>
							</view>
						</view>
					</view>
				</view>
				<view class="searchbox" style="margin: 0 20px;margin-bottom: 30px;" v-if="state==0">
					<u-icon name="search" bold="true" size="25" color="rgb(246,185,78)"></u-icon>
					<input type="text" v-model="supkeywords" placeholder="请输入供应商名称" placeholder-style="color:#BBBCBE" />
				</view>
				<view class="aszs flex6">
					<view class="againbtn" @click="restoreALL"><text>重置</text></view>
					<view class="againbtn" style="color: #D8AB5A;border: 1rpx solid #D8AB5A;" @click="makeSureSelect">
						<text>确认</text>
					</view>
				</view>
			</view>
		</u-popup>
		<u-datetime-picker :show="dateshow" v-model="value1" mode="date" @confirm="chooseDate" @cancel="closeDate">
		</u-datetime-picker>
		<!-- 底部删除 -->
		<u-popup :show="editall&&state==1" @close="closeEidt" @open="openEidt" :overlay="false">
			<view class="editbox">
				<view class="chooseall flex6">
					<view class="leftchoose ">
						<radio :checked="quan" @click="makeSureAll" color="#D8AB5A"></radio>
						<text>全选</text>
					</view>
					<view class="surebtn" @click="selectDown">
						完成
					</view>
				</view>
				<view class="choosebtn">
					<view class="delbtn flex1" @click="dele">删除</view>
					<view class="restorebtn flex1" @click="restore">复原</view>
				</view>
			</view>
		</u-popup>
		<u-popup :show="editall&&state==0" @close="closeEidt" @open="openEidt" :overlay="false">
			<view class="editbox">
				<view class="chooseall flex6">
					<view class="leftchoose ">
						<radio :checked="quan" @click="makeSureAll" color="#D8AB5A"></radio>
						<text>全选</text>
					</view>
					<view class="anniu">
						<text class="usa" @click="dele">删除</text>
						<text class="usa" @click="restore">复原</text>
						<text @click="selectDown" class="usa">完成</text>
					</view>
				</view>
				<view class="choosebtn">
					<view class="delbtn flex1" @click="examineFail">审核失败</view>
					<view class="restorebtn flex1" @click="examineSuccess">审核成功</view>
				</view>
			</view>
		</u-popup>
		<tabar></tabar>
	</view>
</template>

<script>
	let that
	import tabar from "@/componet/tabbar/tabbar.vue"
	export default {
		components: {
			tabar
		},
		data() {
			return {
				keywords: '',
				supkeywords:'',
				state: 0,
				show: false,
				editall: false,
				dateshow: false,
				quan: false,
				creatTime: '',
				endTime: '',
				value1: Number(new Date()),
				intime: 1,
				contract_status: '',
				draft_status: '',
				time_status: '',
				listall: [],
				pageIndex: 1,
				total: '',
				nomore: false,
				shai: false,
				startTime:'',
				ctrstatus: [{
					title: "合同状态",
					list: [{
							name: "全部",

						},
						{
							name: "待审核",

						},
						{
							name: "成功",

						},
						{
							name: "失败",

						},
						{
							name: "已删除",

						},
					]
				}],
				billstatus: [{
					title: "汇票状态",
					list: [{
							name: "全部",

						},
						{
							name: "待审核",

						},
						{
							name: "成功",

						},
						{
							name: "失败",

						},
						{
							name: "已删除",

						},
					]
				}],
				upstauts: [{
					title: "上传日期",
					list: [{
							name: "全部",

						},
						{
							name: "今日",

						},
						{
							name: "昨日",

						},
						{
							name: "自定义",

						},
					]
				}],

			}
		},
		onLoad() {
			that = this
			this.state = this.$store.state.admin
			// this.init()
		},
		onShow() {
			that.pageIndex = 1
			that.nomore = false
			that.listall = []
			this.init()
		},
		// 下拉到底部后加载新数据
		onReachBottom() {
			//判断下一页是否存在数据，不存在将显示暂无数据等提示语
			if (this.listall.length >= this.pageIndex * 10) {
				this.pageIndex++; //页数加一
				this.init(); //回调接口
			} else {
				this.nomore = true
			}

		},
		methods: {

			init() {
				uni.showLoading()
				uni.$u.http.post('/api/Contract/search', {
					pageIndex: this.pageIndex,
					pageSize: 10,
					startTime: this.creatTime,
					endTime: this.endTime,
					name: this.keywords,
					contractStatus: this.contract_status,
					draftStatus: this.draft_status,
					supplierName:this.supkeywords
				}, {
					custom: {
						auth: true
					}
				}).then((res) => {
					uni.hideLoading()
					this.total = res.total

					let list = res.result
					if (list.length > 0) {
						list.forEach(item => {
							item.checked = false
							this.listall.push(item)
						})
						if (list.length < 10) {
							that.nomore = true
						}
					}
				}).catch((err) => {
					uni.hideLoading()
					console.log(err)
				})

			},
			changeSeach(e){
				this.keywords=e.detail.value
				that.pageIndex = 1
				that.nomore = false
				that.listall = []
				this.init()
			},
			examineFail() {
				let ids = []
				that.listall.forEach(item => {
					if (item.checked) {
						ids.push(item.id)
					}
				})
				if (ids.length == 0) {
					this.$toast("请选择合同")
					return
				}
				uni.showModal({
					title: '提示',
					content: '是否批量审核失败？',
					success: function(res) {
						if (res.confirm) {

							uni.showLoading()
							uni.$u.http.post('/api/Contract/manage', {
								ids: ids,
								operateType: 4
							}, {
								custom: {
									auth: true
								}
							}).then((res) => {
								uni.hideLoading()
								that.editall = false
								that.quan = false
								that.$toast("操作成功")
								setTimeout(() => {
									that.pageIndex = 1
									that.nomore = false
									that.listall = []
									that.init()
								}, 500)
							}).catch((err) => {
								uni.hideLoading()
								that.$toast(err.msg)
							})
						} else if (res.cancel) {
							console.log('用户点击取消');
						}
					}
				});

			},
			dele() {
				let ids = []
				that.listall.forEach(item => {
					if (item.checked) {
						ids.push(item.id)
					}
				})
				if (ids.length == 0) {
					that.$toast("请选择合同")
					return
				}
				uni.showModal({
					title: '提示',
					content: "是否批量删除？",
					success: function(res) {
						if (res.confirm) {

							uni.showLoading()
							uni.$u.http.post('/api/Contract/manage', {
								ids: ids,
								operateType: 1
							}, {
								custom: {
									auth: true
								}
							}).then((res) => {
								uni.hideLoading()
								that.editall = false
								that.quan = false
								that.$toast("操作成功")
								setTimeout(() => {
									that.pageIndex = 1
									that.nomore = false
									that.listall = []
									that.init()
								}, 500)

							}).catch((err) => {
								uni.hideLoading()
								that.$toast(err.msg)
							})

						} else if (res.cancel) {

						}
					}
				})

			},
			restore() {
				let ids = []
				that.listall.forEach(item => {
					if (item.checked) {
						ids.push(item.id)
					}
				})
				if (ids.length == 0) {
					that.$toast("请选择合同")
					return
				}
				uni.showModal({
					title: '提示',
					content: "是否批量复原？",
					success: function(res) {
						if (res.confirm) {

							uni.showLoading()
							uni.$u.http.post('/api/Contract/manage', {
								ids: ids,
								operateType: 2
							}, {
								custom: {
									auth: true
								}
							}).then((res) => {
								uni.hideLoading()
								that.editall = false
								that.quan = false
								that.$toast("操作成功")
								setTimeout(() => {
									that.pageIndex = 1
									that.nomore = false
									that.listall = []
									that.init()
								}, 500)

							}).catch((err) => {
								uni.hideLoading()
								that.$toast(err.msg)
							})

						} else if (res.cancel) {

						}
					}
				})

			},
			examineSuccess() {
				let ids = []
				that.listall.forEach(item => {
					if (item.checked) {
						ids.push(item.id)
					}
				})
				if (ids.length == 0) {
					that.$toast("请选择合同")
					return
				}
				uni.showModal({
					title: '提示',
					content: "是否批量审核成功？",
					success: function(res) {
						if (res.confirm) {

							uni.showLoading()
							uni.$u.http.post('/api/Contract/manage', {
								ids: ids,
								operateType: 3
							}, {
								custom: {
									auth: true
								}
							}).then((res) => {
								uni.hideLoading()
								that.editall = false
								that.quan = false
								that.$toast("操作成功")
								setTimeout(() => {
									that.pageIndex = 1
									that.nomore = false
									that.listall = []
									that.init()
								}, 500)

							}).catch((err) => {
								uni.hideLoading()
								that.$toast(err.msg)
							})

						} else if (res.cancel) {

						}
					}
				})

			},

			checkBox(id) {
				let list = this.listall
				list.forEach(item => {
					if (item.id == id) {
						item.checked = !item.checked
					}
				})
				this.listall = JSON.parse(JSON.stringify(list))

			},
			allSelect() {
				let list = this.listall
				if (this.quan) {
					list.forEach(item => {
						item.checked = true
					})
				} else {
					list.forEach(item => {
						item.checked = false
					})
				}
				this.listall = JSON.parse(JSON.stringify(list))
				console.log(this.listall)
			},
			addContract() {
				uni.navigateTo({
					url: '/pages/alldeatil/upcontract'
				})
			},
			moveDetail(id) {
				uni.navigateTo({
					url: "/pages/alldeatil/contractdetail?id=" + id
				})
			},
			makeSureAll() {
				this.quan = !this.quan
				this.allSelect()
			},
			selectDown() {
				this.editall = false
				this.quan = false
				let list = this.listall
				list.forEach(item => {
					item.checked = false
				})
			},
			closeEidt() {
				this.editall = false
			},
			openEidt() {
				this.editall = true
			},
			chooseDate(e) {
				this.dateshow = false
				const timeFormat = uni.$u.timeFormat
				if (this.intime == 1) {
					this.creatTime = timeFormat(e.value, 'yyyy-mm-dd')
				} else {
					this.endTime = timeFormat(e.value, 'yyyy-mm-dd')
				}

			},
			openDatePicker(e) {
				console.log(e)
				if (e == 1) {
					this.intime = 1
				} else {
					this.intime = 2
				}
				this.dateshow = true
			},
			closeDate() {
				this.dateshow = false
			},
			open() {
				// console.log('open');
			},
			close() {
				this.show = false
				// console.log('close');
			},
			makeSureSelect() {
				this.shai = true
				that.pageIndex = 1
				that.nomore = false
				that.listall = []
				this.init()
				this.close()
			},
			restoreALL() {
				this.creatTime = ''
				this.endTime = ''
				this.time_status = 0
				this.contract_status = 0
					this.draft_status = 0
					that.pageIndex = 1
					that.nomore = false
					that.listall = []
					this.init()
			},
			choose(title, k) {
				if (title == "合同状态") {
					this.contract_status = k
				} else if (title == "汇票状态") {
					this.draft_status = k
				} else if (title == "上传日期") {
					this.time_status = k
					if (k == 0) {
						this.creatTime = ''
					} else if (k == 1) {
						let myDate = new Date()
						let yy = String(myDate.getFullYear())
						let mm = String(myDate.getMonth() + 1 < 10 ? '0' + (myDate.getMonth() + 1) : myDate.getMonth() + 1)
						let dd = String(myDate.getDate() < 10 ? '0' + myDate.getDate() : myDate.getDate())
						let nowDate = yy + '-' + mm + '-' + dd
						this.creatTime = nowDate
					} else if (k == 2) {
						let myDate = new Date()
						let yy = String(myDate.getFullYear())
						let mm = String(myDate.getMonth() + 1 < 10 ? '0' + (myDate.getMonth() + 1) : myDate.getMonth() + 1)
						let dd = String(myDate.getDate() - 1 < 10 ? '0' + myDate.getDate() - 1 : myDate.getDate() - 1)
						let nowDate = yy + '-' + mm + '-' + dd
						this.creatTime = nowDate
					}

				}
			}
		}
	}
</script>

<style lang="scss">
	page {
		background-color: #F6F6F6 !important;
	}

	.headbgbox {
		background-color: #fff;
		padding: 23rpx 31rpx;
		box-sizing: border-box;
		position: fixed;
		top: 0;
		z-index: 999;
		width: 100%;

		.screen {
			display: flex;
			justify-content: center;
			align-items: center;
			padding-left: 30rpx;
		}
	}

	.searchbox {
		padding-left: 30rpx;
		box-sizing: border-box;
		background-color: #ECECEC;
		border-radius: 38rpx;
		// width: 688rpx;
		flex: 1;
		height: 75rpx;
		margin: 0 auto;
		display: flex;
		align-items: center;

		// justify-content: center;
		// margin-top: -10rpx;
		input {
			width: 240px;
			overflow: hidden;
			text-overflow: ellipsis;
			white-space: nowrap;
		}
	}

	.cardlist {
		display: flex;
		justify-content: center;
		flex-direction: column;
		// align-items: center;
		margin: 0 auto;
		margin-top: 120rpx;
	}

	.lable {
		display: flex;
		margin: 0 auto;
		margin-top: 20rpx;

		.radiobox {
			margin-right: -10rpx;
			margin-left: 30rpx;
		}
	}

	.card {
		flex: 1;
		overflow: hidden;
		margin: 0 30rpx;
		// width: 690rpx;
		// height: 315rpx;
		border-radius: 20rpx;
		background-color: #fff;
		position: relative;
		box-shadow: 0px 8rpx 20rpx 1rpx rgba(31, 36, 42, 0.08);

		.passreview {
			position: absolute;
			right: 30rpx;
			top: 30rpx;
			width: 141rpx;
			height: 123.5rpx;

			image {
				width: 100%;
				height: 100%;
			}
		}

		.contadra {
			font-size: 24rpx;
			color: #BEBDBB;
			padding: 20rpx 0;
			margin: 0 30rpx;
			border-top: 1rpx solid #E8E8E8;

		}

		.innerbox {
			padding: 49rpx 0rpx;
			padding-bottom: 30rpx;
			margin: 0 30rpx;
			display: flex;
			align-items: center;
			border-bottom: 1rpx solid #E8E8E8;

			.listicon {
				width: 32rpx;
				height: 36rpx;

				image {
					width: 100%;
					height: 100%;
				}
			}
		}

		.cardtitle {
			display: block;
			max-width: 390rpx;
			font-size: 32rpx;
			font-weight: 600;
			padding-left: 10rpx;
		}

		.timebox {
			background-color: #FFF8E5;
			width: 100%;
			padding: 0 30rpx;
			box-sizing: border-box;
			color: #D8AB5A;
			font-size: 28rpx;
			height: 60rpx;
			line-height: 60rpx;
		}

		.contractmsg {
			padding: 30rpx;
			box-sizing: border-box;
			color: #68625B;
			font-size: 26rpx;
			// border-bottom: 1rpx solid #E8E8E8;
		}
	}


	.totalmanage {
		margin-top: 90rpx;
		margin-bottom: 100rpx;
		// position: fixed;
		// bottom: 0;
		display: flex;
		justify-content: space-between;
		align-items: center;
		width: 100%;
		padding: 0 30rpx;

		box-sizing: border-box;

		.managebox {
			width: 23.8rpx;
			height: 29.7rpx;

			image {
				width: 100%;
				height: 100%;
			}
		}

		.maboxtitls {
			width: 160rpx;
			height: 60rpx;
			display: flex;
			align-items: center;
			justify-content: center;
			border-radius: 30rpx;
			background-color: #D9D9D9;
			// line-height: 60rpx;
			font-size: 28rpx;
			box-sizing: border-box;
			// align-items: center;
		}
	}
</style>
